﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

using System.Drawing.Drawing2D;
using System.IO;

namespace howto_make_icon_from_files
{
    public partial class Form1 : Form
    {

        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            lvwFiles.LargeImageList = imlFiles;
            lvwFiles.View = View.Tile;
            imlFiles.ImageSize = new Size(64, 64);
        }

        private void mnuFileOpen_Click(object sender, EventArgs e)
        {
            if (ofdImages.ShowDialog() == DialogResult.OK)
            {
                foreach (string filename in ofdImages.FileNames)
                {
                    Bitmap bm = new Bitmap(filename);
                    imlFiles.Images.Add(bm);
                    lvwFiles.Items.Add(filename, imlFiles.Images.Count - 1);
                }
                mnuFileSaveAs.Enabled = (lvwFiles.Items.Count > 0);
            }
        }

        private void mnuFileSaveAs_Click(object sender, EventArgs e)
        {
            if (sfdIcon.ShowDialog() == DialogResult.OK)
            {
                List<Bitmap> bitmaps = new List<Bitmap>();
                foreach (ListViewItem item in lvwFiles.Items)
                {
                    bitmaps.Add(new Bitmap(item.Text));
                }

                IconFactory.SavePngsAsIcon(
                    bitmaps, sfdIcon.FileName, true);
                this.Icon = new Icon(sfdIcon.FileName);
            }
        }

        private void mnuFileExit_Click(object sender, EventArgs e)
        {
            Close();
        }

        private void mnuItemsClear_Click(object sender, EventArgs e)
        {
            lvwFiles.Items.Clear();
            imlFiles.Images.Clear();
            mnuFileSaveAs.Enabled = (lvwFiles.Items.Count > 0);
        }

        private void lvwFiles_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.KeyCode == Keys.Delete)
            {
                foreach (ListViewItem item in lvwFiles.SelectedItems)
                {
                    item.Remove();
                }

                if (lvwFiles.Items.Count == 0)
                {
                    mnuFileSaveAs.Enabled = false;
                    imlFiles.Images.Clear();
                }
            }
        }
    }
}
